import java.text.Collator

class Candidato implements Comparable<Object> {
    private String nome
    private int numero
    private int numVotos
    private boolean eleito
    private Partido p
    private Coligacao c

    Candidato(String nome, int numero,int numVotos, boolean eleito, Partido p,Coligacao c){
        this.nome = nome
        this.numero = numero
        this.numVotos = numVotos
        this.eleito = eleito
        this.setP(p)
        this.c=c
    }

    Coligacao getC() {
        return c
    }

    String getNome() {
        return nome
    }

    int getNumVotos() {
        return numVotos
    }

    boolean isEleito() {
        if (eleito){
            return true
        }
        return false
    }

    Partido getP() {
        return p
    }

    void setP(Partido p) {
        this.p = p
    }

    int compareTo(Object o){
        Collator collator = Collator.getInstance (new Locale ("pt", "BR"))
        collator.setStrength(Collator.PRIMARY)
        Candidato g = (Candidato) o
        if (this.getNumVotos() > g.getNumVotos()){
            return -1
        }else{
            return 1
        }
    }
}
