class Impressor {

    Impressor (){

    }

    static void numVag (int numVagas){
        println("Número de vagas: " + numVagas + "\n")
    }

    static verEleitos = { LinkedList<Candidato> candidatos ->
        int i, j

        println("Vereadores Eleitos:")
        //candidatos eleitos
        for (i = 0; i < candidatos.size(); i++) {
            if (candidatos.get(i).isEleito()) {
                j = i + 1
                String[] part = candidatos.get(i).getC().getNome().split("/")
                if (part.length > 1) {
                    println(j + " - " + candidatos.get(i).getNome() + " (" + candidatos.get(i).getP().getNome() + ", " + candidatos.get(i).getNumVotos() + " votos) - Coligação:" + candidatos.get(i).getP().getC().getNome())
                } else {
                    println(j + " - " + candidatos.get(i).getNome() + " (" + candidatos.get(i).getP().getNome() + ", " + candidatos.get(i).getNumVotos() + " votos)")
                }
            }
        }
    }

    void candMaisVotados(int numVagas, LinkedList<Candidato> candidatos){
        int i,j
        //candidatos mais votados
        println("\nCandidatos mais votados (em ordem decrescente de votação e respeitando número de vagas):")
        Collections.sort(candidatos)
        for(i=0 ; i < numVagas ; i++){
            j = i+1
            String[] part = candidatos.get(i).getC().getNome().split("/")
            if(part.length>1){
                println(j + " - " + candidatos.get(i).getNome() + " (" + candidatos.get(i).getP().getNome() + ", " +candidatos.get(i).getNumVotos() + " votos) - Coligação:" + candidatos.get(i).getP().getC().getNome())
            }else{
                println(j + " - " + candidatos.get(i).getNome() + " (" + candidatos.get(i).getP().getNome() + ", " +candidatos.get(i).getNumVotos() + " votos)")
            }
        }
    }

    void candPrejudicadoseBeneficiados(int numVagas, LinkedList<Candidato> candidatos){
        //teriam sido eleitos se a votação fosse majoritaria, e não foram eleitos
        println("\nTeriam sido eleitos se a votação fosse majoritária, e não foram eleitos:\n(com sua posição no ranking de mais votados)")
        int i,contador=1,menorVotoReal=0,menorVotos=0
        for(i=0;i<candidatos.size();i++){
            if(candidatos.get(i).isEleito()){
                menorVotos=candidatos.get(i).getNumVotos()
            }
        }
        for(Candidato candis : candidatos){
            if((candis.getNumVotos()>menorVotos)&&(!candis.isEleito())&&(contador<=numVagas)){
                menorVotoReal=candis.getNumVotos()
                String[] part = candis.getC().getNome().split("/")
                if(part.length>1){
                    println(contador + " - " + candis.getNome() + " (" + candis.getP().getNome() + ", " +candis.getNumVotos() + " votos) - Coligação:" + candis.getP().getC().getNome())
                }else{
                    println(contador + " - " + candis.getNome() + " (" + candis.getP().getNome() + ", " +candis.getNumVotos() + " votos)")
                }

            }
            contador++
        }
        //foram eleitos, mas não seriam se a votação fosse majoritaria
        contador=1
        println("\nEleitos, que se beneficiaram do sistema proporcional:(com sua posição no ranking de mais votados)")
        for(Candidato candidat:candidatos){
            if((candidat.getNumVotos()<menorVotoReal)&&(candidat.isEleito())){
                String[] part = candidat.getC().getNome().split("/")
                if(part.length>1){
                    println(contador + " - " + candidat.getNome() + " (" + candidat.getP().getNome() + ", " +candidat.getNumVotos() + " votos) - Coligação:" + candidat.getP().getC().getNome())
                }else{
                    println(contador + " - " + candidat.getNome() + " (" + candidat.getP().getNome() + ", " +candidat.getNumVotos() + " votos)")
                }
            }
            contador++
        }
    }

    static void votColigacoes (LinkedList<Coligacao> coligacoes){
        int contador=1
        //Votação das coligações e número de candidatos eleitos
        println("\n Votação (nominal) das coligações e número de candidatos eleitos:") //tem que ajeitar plural e vê ordenação
        for(Coligacao colig : coligacoes){
            print(contador+" - Coligacao: "+colig.getNome()+",")
            int contadorVotos =0
            int contadorEleito = 0
            LinkedList <Partido> partidoColicagao = colig.getPartidos()
            for(Partido part : partidoColicagao){
                for(Candidato candis : part.getCandidatos()){
                    contadorVotos= contadorVotos+ candis.getNumVotos()
                    if(candis.isEleito()){
                        contadorEleito++
                    }
                }
            }
            println(contadorVotos+" votos, " + contadorEleito+" candidatos eleitos")
            contador++
        }
    }
    public void votPartidos (LinkedList<Partido> partidos){
        //Votação dos partidos e número de candidatos eleitos
        int contador=1
        println("\nVotação (nominal) dos partidos e número de candidatos eleitos:") // tem que ajeitar plural e vê ordenação
        for(Partido pas : partidos){
            int contadorVotos =0
            int contadorEleito = 0
            print(contador+" - "+pas.getNome()+",")
            for(Candidato candit : pas.getCandidatos()){
                contadorVotos=contadorVotos+candit.getNumVotos()
                if(candit.isEleito()){
                    contadorEleito++
                }
            }
            println(contadorVotos+" votos, " + contadorEleito+ " candidatos eleitos")
            contador++
        }
    }


    static void totVotos(LinkedList<Candidato> candidatos){
        //Total de Votos
        int i,totalVotos=0
        for(i=0 ; i < candidatos.size() ; i++){
            totalVotos = totalVotos + candidatos.get(i).getNumVotos()
        }
        println("\nTotal de votos nominais: " + totalVotos)
    }


}
